package lcsb.mapviewer.api.genomics;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.CookieValue;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import lcsb.mapviewer.api.BaseController;
import lcsb.mapviewer.api.QueryException;
import lcsb.mapviewer.common.Configuration;
import lcsb.mapviewer.services.SecurityException;
import lcsb.mapviewer.services.view.ReferenceGenomeView;

@RestController
public class ReferenceGenomeController extends BaseController {

	@Autowired
	private ReferenceGenomeRestImpl referenceGenomeController;

	@RequestMapping(value = "/genomics/taxonomies/{organismId}/genomeTypes/{type}/versions/{version}/", method = { RequestMethod.GET, RequestMethod.POST },
			produces = { MediaType.APPLICATION_JSON_VALUE })
	public ReferenceGenomeView getDrugsByQuery(//
			@CookieValue(value = Configuration.AUTH_TOKEN) String token, //
			@PathVariable(value = "organism") String organism, //
			@PathVariable(value = "type") String type, //
			@PathVariable(value = "version") String version//
	) throws SecurityException, QueryException {
		return referenceGenomeController.getReferenceGenome(token, organism, type, version);
	}
}